/*
 * Ubiquity REST API
 * Ubiquity provides a RESTful and uniform way to access blockchain resources, with a rich and reusable model across multiple cryptocurrencies.  [Documentation](https://app.blockdaemon.com/docs/ubiquity)  ### Protocols #### Mainnet The following protocols are currently supported: * bitcoin * ethereum * polkadot * xrp * algorand * stellar * dogecoin * oasis * stacks * near  #### Testnet * bitcoin/testnet * ethereum/ropsten * dogecoin/testnet  #### Native Ubiquity provides native access to all Blockchain nodes it supports. To access native functionality, use the protocol without the v2 prefix * bitcoin/(mainnet | testnet) - [RPC Documentation](https://developer.bitcoin.org/reference/rpc/) * ethereum/(mainnet | ropsten) - [RPC Documentation](https://ethereum.org/en/developers/docs/apis/json-rpc/) * polkadot/mainnet - [Sidecar API Documentation](https://paritytech.github.io/substrate-api-sidecar/dist/) * polkadot/mainnet/http-rpc - [Polkadot RPC Documentation](https://polkadot.js.org/docs/substrate/rpc/) * algorand/mainnet - [Algod API Documentation](https://developer.algorand.org/docs/reference/rest-apis/algod/v1/) * stellar/mainnet - [Stellar Horizon API Documentation](https://developers.stellar.org/api) * dogecoin/(mainnet | testnet) - [Dogecoin API Documentaion](https://developer.bitcoin.org/reference/rpc/) * oasis/mainnet - [Oasis Rosetta Gateway Documentation](https://www.rosetta-api.org/docs/api_identifiers.html#network-identifier) * stacks/mainnet - [Stacks API Documentation](https://blockstack.github.io/stacks-blockchain-api/) * near/mainnet - [NEAR RPC Documentation](https://docs.near.org/docs/api/rpc)  A full URL example: https://ubiquity.api.blockdaemon.com/_**bitcoin/mainnet**  ##### Pagination Certain resources contain a lot of data, more than what's practical to return for a single request. With the help of pagination, the data is split across multiple responses. Each response returns a subset of the items requested, and a continuation token.  To get the next batch of items, copy the returned continuation token to the continuation query parameter and repeat the request with the new URL. In case no continuation token is returned, there is no more data available. 
 *
 * The version of the OpenAPI document: 2.0.0
 * Contact: support@blockdaemon.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package com.gitlab.blockdaemon.ubiquity.model;

import java.util.Objects;
import java.util.Arrays;
import java.util.Map;
import java.util.HashMap;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonTypeName;
import com.fasterxml.jackson.annotation.JsonValue;
import com.gitlab.blockdaemon.ubiquity.model.Supply;
import com.gitlab.blockdaemon.ubiquity.model.Tx;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import com.fasterxml.jackson.annotation.JsonPropertyOrder;
import com.gitlab.blockdaemon.ubiquity.invoker.JSON;


/**
 * Block
 */
@JsonPropertyOrder({
  Block.JSON_PROPERTY_NUMBER,
  Block.JSON_PROPERTY_ID,
  Block.JSON_PROPERTY_PARENT_ID,
  Block.JSON_PROPERTY_DATE,
  Block.JSON_PROPERTY_TX_IDS,
  Block.JSON_PROPERTY_TXS,
  Block.JSON_PROPERTY_SUPPLY
})
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen")
public class Block {
  public static final String JSON_PROPERTY_NUMBER = "number";
  private Long number;

  public static final String JSON_PROPERTY_ID = "id";
  private String id;

  public static final String JSON_PROPERTY_PARENT_ID = "parent_id";
  private String parentId;

  public static final String JSON_PROPERTY_DATE = "date";
  private Long date;

  public static final String JSON_PROPERTY_TX_IDS = "tx_ids";
  private List<String> txIds = null;

  public static final String JSON_PROPERTY_TXS = "txs";
  private List<Tx> txs = null;

  public static final String JSON_PROPERTY_SUPPLY = "supply";
  private Map<String, Supply> supply = null;


  public Block number(Long number) {
    this.number = number;
    return this;
  }

   /**
   * Block number
   * @return number
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "8000000", value = "Block number")
  @JsonProperty(JSON_PROPERTY_NUMBER)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public Long getNumber() {
    return number;
  }


  @JsonProperty(JSON_PROPERTY_NUMBER)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
  public void setNumber(Long number) {
    this.number = number;
  }


  public Block id(String id) {
    this.id = id;
    return this;
  }

   /**
   * Block hash
   * @return id
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "0x123456070D674D44a7F9cb4Ab272bd88fAd004b5", value = "Block hash")
  @JsonProperty(JSON_PROPERTY_ID)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public String getId() {
    return id;
  }


  @JsonProperty(JSON_PROPERTY_ID)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
  public void setId(String id) {
    this.id = id;
  }


  public Block parentId(String parentId) {
    this.parentId = parentId;
    return this;
  }

   /**
   * Parent block hash
   * @return parentId
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "0xfcf029ffd36a6714aae09dcc7acbdd8f2b96327f", value = "Parent block hash")
  @JsonProperty(JSON_PROPERTY_PARENT_ID)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public String getParentId() {
    return parentId;
  }


  @JsonProperty(JSON_PROPERTY_PARENT_ID)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
  public void setParentId(String parentId) {
    this.parentId = parentId;
  }


  public Block date(Long date) {
    this.date = date;
    return this;
  }

   /**
   * Unix timestamp
   * @return date
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "1571222657", value = "Unix timestamp")
  @JsonProperty(JSON_PROPERTY_DATE)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public Long getDate() {
    return date;
  }


  @JsonProperty(JSON_PROPERTY_DATE)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
  public void setDate(Long date) {
    this.date = date;
  }


  public Block txIds(List<String> txIds) {
    this.txIds = txIds;
    return this;
  }

  public Block addTxIdsItem(String txIdsItem) {
    if (this.txIds == null) {
      this.txIds = new ArrayList<>();
    }
    this.txIds.add(txIdsItem);
    return this;
  }

   /**
   * Complete list of transaction IDs
   * @return txIds
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "Complete list of transaction IDs")
  @JsonProperty(JSON_PROPERTY_TX_IDS)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public List<String> getTxIds() {
    return txIds;
  }


  @JsonProperty(JSON_PROPERTY_TX_IDS)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
  public void setTxIds(List<String> txIds) {
    this.txIds = txIds;
  }


  public Block txs(List<Tx> txs) {
    this.txs = txs;
    return this;
  }

  public Block addTxsItem(Tx txsItem) {
    if (this.txs == null) {
      this.txs = new ArrayList<>();
    }
    this.txs.add(txsItem);
    return this;
  }

   /**
   * Partial list of normalized transactions (not filtered or unknown model)
   * @return txs
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "Partial list of normalized transactions (not filtered or unknown model)")
  @JsonProperty(JSON_PROPERTY_TXS)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public List<Tx> getTxs() {
    return txs;
  }


  @JsonProperty(JSON_PROPERTY_TXS)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
  public void setTxs(List<Tx> txs) {
    this.txs = txs;
  }


  public Block supply(Map<String, Supply> supply) {
    this.supply = supply;
    return this;
  }

  public Block putSupplyItem(String key, Supply supplyItem) {
    if (this.supply == null) {
      this.supply = new HashMap<>();
    }
    this.supply.put(key, supplyItem);
    return this;
  }

   /**
   * Coin supplies with asset paths as keys
   * @return supply
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "Coin supplies with asset paths as keys")
  @JsonProperty(JSON_PROPERTY_SUPPLY)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public Map<String, Supply> getSupply() {
    return supply;
  }


  @JsonProperty(JSON_PROPERTY_SUPPLY)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
  public void setSupply(Map<String, Supply> supply) {
    this.supply = supply;
  }


  /**
   * Return true if this block object is equal to o.
   */
  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Block block = (Block) o;
    return Objects.equals(this.number, block.number) &&
        Objects.equals(this.id, block.id) &&
        Objects.equals(this.parentId, block.parentId) &&
        Objects.equals(this.date, block.date) &&
        Objects.equals(this.txIds, block.txIds) &&
        Objects.equals(this.txs, block.txs) &&
        Objects.equals(this.supply, block.supply);
  }

  @Override
  public int hashCode() {
    return Objects.hash(number, id, parentId, date, txIds, txs, supply);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Block {\n");
    sb.append("    number: ").append(toIndentedString(number)).append("\n");
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    parentId: ").append(toIndentedString(parentId)).append("\n");
    sb.append("    date: ").append(toIndentedString(date)).append("\n");
    sb.append("    txIds: ").append(toIndentedString(txIds)).append("\n");
    sb.append("    txs: ").append(toIndentedString(txs)).append("\n");
    sb.append("    supply: ").append(toIndentedString(supply)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

